<template>
  <div
    ref="selfRef" class="card-container w-100"
    @focus="selfFocusEnter()" @blur="selfFocusLeave()"
    @mouseenter="() => { if (mode === 'DEFAULT') selfFocusEnter()}" @mouseleave="selfFocusLeave()"
  >
    <v-icon v-if="isFocused" :color="selfColor" class="chevron-icon" size="35">mdi-chevron-right</v-icon>
    <v-tooltip
      v-model="isFocused"
      location="bottom"
      :open-on-hover="false"
    >
    Actions : <v-icon size="small">mdi-keyboard-space</v-icon> <v-icon size="small">mdi-keyboard-return</v-icon> detail · <u>E</u>dit · <u>Del</u>
      <template v-slot:activator="{ props }">
        <ck-card-with-progress
          :loading="loading"
          v-bind="props"
          :percentage="percentage"
          :color="selfColor"
          :ripple="mode === 'DEFAULT'"
          @click="() => { gotoChecklistView() }"
        >
          <contenu-carte-checklist
            v-if="mode === 'DEFAULT' || mode === 'DELETE'"
            :nbCompletedItems="checklist.nbCompletedItems"
            :nbItems="checklist.nbItems"
            :titre="checklist.titre"
            :color="selfColor"
            :hideActions="mode === 'DELETE'"
            @EDIT="setupEdit()"
            @DELETE="setupDelete()"
          >{{ checklist.description }}</contenu-carte-checklist>
          <contenu-edition-carte-checklist
            v-else-if="mode === 'EDIT'"
            v-model="tempchecklist"
            @UPDATE="updateChecklist(tempchecklist)"
            @CANCEL="teardownEdit()"
          ></contenu-edition-carte-checklist>
          <contenu-supression-carte-checklist
            color="error"
            v-if="mode === 'DELETE'"
            @DELETE="deleteChecklist(this.checklist.id)"
            @CANCEL="teardownDelete()"
          ></contenu-supression-carte-checklist>
        </ck-card-with-progress>
      </template>
    </v-tooltip>
  </div>
</template>



<script>
import { toRaw } from 'vue'
import { useChecklistStore } from '@/stores/checklists.js'
import { useKeypress } from 'vue3-keypress'
import CkCardWithProgress from '@/components/commons/ck-card-with-progress.vue'
import ContenuCarteChecklist from '@/components/checklist/contenu-carte-checklist.vue'
import ContenuEditionCarteChecklist from '@/components/checklist/contenu-editon-carte-checklist.vue'
import ContenuSupressionCarteChecklist from '@/components/checklist/contenu-supression-carte-checklist.vue'

export default {
  name: "checklist-card",
  components: { ContenuSupressionCarteChecklist, ContenuEditionCarteChecklist, ContenuCarteChecklist, CkCardWithProgress },
  data() {
    return {
      tempchecklist: undefined,
      mode: "DEFAULT",
      isFocused: false,
      loading: false
    }
  },
  props: {
    checklist: {
      type: Object,
      required: true
    },
    focusOnMount:  {
      type: Boolean,
      default: false
    }
  },
  computed: {
    selfColor() {
      return this.percentage > 99 ? 'success' : 'primary'
    },
    percentage() {
      return this.checklist.nbItems > 0 ?
        (100*this.checklist.nbCompletedItems)/this.checklist.nbItems :
        0
    },
  },
  methods: {
    gotoChecklistView() {
      if (this.mode === 'DEFAULT') this.$router.push({ name: 'checklist', params: { checklistId: this.checklist.id }})
    },
    selfFocusEnter() {
      this.$refs.selfRef.focus()
      this.isFocused = true
    },
    selfFocusLeave() {
      this.$refs.selfRef.blur()
      this.isFocused = false
    },
    setupEdit() {
      this.tempchecklist = structuredClone(toRaw(this.checklist))
      this.mode = "EDIT"
    },
    setupDelete() {
      this.mode = "DELETE"
    },
    teardownEdit() {
      this.tempchecklist = undefined
      this.mode = "DEFAULT"
      this.$nextTick(() => {
        this.selfFocusEnter()
      });
    },
    teardownDelete() {
      this.mode = "DEFAULT"
      this.$nextTick(() => {
        this.selfFocusEnter()
      });
    },
    updateChecklist(_toUpdate) {
      this.loading = true
      useChecklistStore().updateChecklist(_toUpdate).then(() => {
        this.loading = false
        this.teardownEdit()
      })
    },
    deleteChecklist(id) {
      this.loading = true
      this.mode = 'DEFAULT'
      useChecklistStore().deleteChecklist(id).then(() => {
        this.loading = false
        this.teardownDelete()
      })
    }
  },
  created() {
    useKeypress({
      keyEvent: "keyup",
      keyBinds: [
        {
          keyCode: 32, // Space key
          success: () => { if (this.isFocused) this.gotoChecklistView() },
          preventDefault: true
        },
        {
          keyCode: 13, // Enter key
          success: () => { if (this.isFocused) this.gotoChecklistView() },
          preventDefault: true
        },
        {
          keyCode: 69, // 'e'
          success: () => {if (this.isFocused) this.setupEdit()},
          preventDefault: true
        },
        {
          keyCode: 27, // Escape key
          success: () => {
            if (this.mode === "EDIT") this.teardownEdit()
            if (this.mode === "DELETE") this.teardownDelete()
          },
          preventDefault: true
        },
        {
          keyCode: 46, // Delete key
          success: () => {if (this.isFocused) this.setupDelete()},
          preventDefault: true
        },
      ]
    })
  },
  mounted() {
    if (this.focusOnMount) {
      this.selfFocusEnter()
    }
  }
}
</script>

<style lang="scss" scoped>
.chevron-icon {
  position: absolute;
  left: -30px;
  top: 50%;
  transform: translateY(-50%);
}

.card-container {
  position: relative;
  display: inline-block;
  outline: none;
}
</style>